/*
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

define([
    "dojo/_base/lang",
    "./../widgets/base/Gauge",
    "./../widgets/base/Output",
    "./../../uomConverter"
], function (
    lang,
    Gauge,
    Output,
    uomConverter
) {
    function getStorageOutput(options, i18nOptions, i18nMultilang, packageId) {
        var usage = uomConverter.convertByteToMajorityUnit(+options.usage),
            limit = uomConverter.convertByteToMajorityUnit(+options.limit);

        if ((+options.limit) === 0) {
            return new Output(lang.mixin(options, {
                content: options.noneLegend || _('None', i18nOptions, i18nMultilang, packageId),
                usage: usage.value,
                usageUnit: uomConverter.getUnitName(usage.unit, i18nOptions, i18nMultilang, packageId),
                limit: limit.value,
                limitUnit: uomConverter.getUnitName(limit.unit, i18nOptions, i18nMultilang, packageId)
            }));
        }
        if ((+options.limit) <= 0) {
            return new Output(lang.mixin(options, {
                content: options.unlimitedLegend || "${usage} ${usageUnit}",
                usage: usage.value,
                usageUnit: uomConverter.getUnitName(usage.unit, i18nOptions, i18nMultilang, packageId),
                limit: limit.value,
                limitUnit: uomConverter.getUnitName(limit.unit, i18nOptions, i18nMultilang, packageId)
            }));
        }
        if ((+options.usage) === 0) {
            return new Output(lang.mixin(options, {
                content: options.zeroUsageLegend || _("${limit} ${limitUnit} available", i18nOptions, i18nMultilang, packageId),
                usage: usage.value,
                usageUnit: uomConverter.getUnitName(usage.unit, i18nOptions, i18nMultilang, packageId),
                limit: limit.value,
                limitUnit: uomConverter.getUnitName(limit.unit, i18nOptions, i18nMultilang, packageId)
            }));
        }

        var classesMap = {};
        classesMap[Math.round(+options.limit * 0.5)] = "warn";
        classesMap[Math.round(+options.limit * 0.75)] = "over";
        return new Gauge(lang.mixin(options, {
            legend: options.limitedLegend || "${usage} ${usageUnit} / ${limit} ${limitUnit}",
            minimum: 0,
            maximum: +options.limit,
            value: +options.usage,
            usage: usage.value,
            usageUnit: uomConverter.getUnitName(usage.unit, i18nOptions, i18nMultilang, packageId),
            limit: limit.value,
            limitUnit: uomConverter.getUnitName(limit.unit, i18nOptions, i18nMultilang, packageId)
        }));
    }

    return getStorageOutput;
});

