/**
 * @Copyright © 2002-2020 Acronis International GmbH. All rights reserved
 */

define([
    './../utils',
    './../../common'
], function (
    utils,
    common
) {
    function getTenantButtons(tenant, subscriptionId, trial, canAdjustLimits) {
        return trial ? {
            autoBusy: false,
            title: _('Upgrade to Paid'),
            iconClass: 'fa-shopping-cart',
            onClick: function () {
                aps.apsc.gotoView('http://www.parallels.com/ccp-billing-subscription-management#upgrade-wizard', null, {
                    subscriptionId: subscriptionId,
                    returnUrl: utils.createReturnUrl()
                });
            }
        } : {
            visible: canAdjustLimits,
            autoBusy: false,
            title: _('Adjust Limits'),
            iconClass: 'fa-cog',
            onClick: function () {
                var viewId = tenant.type == common.TENANT_TYPE.PARTNER ? '#nextcp-ccp-partner' : '#nextcp-ccp';
                aps.apsc.gotoView('http://www.parallels.com/ccp-billing#change-resource-limits', null, {
                    subscriptionId: subscriptionId,
                    returnView: 'http://www.acronis.com/aps/cloud-backup-v1' + viewId
                });
            }
        };
    }

    return getTenantButtons;
});

