/*
 * @Copyright © 2002-2022 Acronis International GmbH. All rights reserved
 */

define([
    'aps/nav/ViewPlugin',
    'aps/Tile',
    'aps/Output',
    'dojo/_base/declare',
    './../../common',
    './../../icons'
], function (
    ViewPlugin,
    Tile,
    Output,
    declare,
    common,
    icons
) {
    return declare(ViewPlugin, {
        init: function (mediator) {
            var self = this;
            mediator.getWidget = function () {
                var tile = new Tile({
                    title: _("Cyber Protection", {}, {}, self),
                    gridSize: 'md-4 xs-12',
                    onClick: function () {
                        aps.apsc.gotoView(common.APP_ID + '#nextcp-ccp-reseller');
                    },
                    fontColor: "#ffffff",
                    backgroundColor: "#163584",
                    iconName: self.buildStaticURL(icons.ACRONIS_BACKUP_TILE_150)
                });
                tile.addChild(new Output({
                    value: _('Welcome to Acronis Cyber Cloud, a unique integration of backup with full-stack next-generation anti-malware protection and comprehensive endpoint management tools. This synergy eliminates complexity and improves security so you can have better protection for your data.')
                }))
                return tile;
            };
        }
    });
});
