/*
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

define([
    "aps/WizardData"
], function (
    WizardData
) {
    function getViewId(view) {
        return view ? view : getCurrentView();
    }

    function getCurrentView() {
        return typeof aps.context.viewId === "undefined" ? aps.context.view.id.split('#').pop() : aps.context.viewId;
    }

    return {
        getWizardData: function(view) {
            var wd = WizardData.get();
            if (!wd) {
                return {};
            }
            var viewId = getViewId(view);
            if (!wd.hasOwnProperty(viewId)) {
                return {};
            }
            return wd[viewId];
        },

        setWizardData: function(data, view) {
            var wd = WizardData.get();
            if (!wd) {
                wd = {};
            }
            var viewId = getViewId(view);
            wd[viewId] = data;
            WizardData.put(wd);
        },

        resetWizardData: function(view) {
            var wd = WizardData.get();
            if (!wd) {
                return;
            }
            var viewId = getViewId(view);
            if (!wd.hasOwnProperty(viewId)) {
                return;
            }
            delete wd[viewId];
            WizardData.put(wd);
        }
    };
});
