<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_BaseClient_TransportStrategy_Multipart
    implements Service_BaseClient_TransportStrategy_ITransportStrategy
{
    const CONTENT_TYPE_MULTIPART = "Content-Type: multipart/form-data";
    const FIELD_HREF = 'href';
    const FIELD_FILE_NAME = 'name';
    const FORM_VARIABLE_FILE = 'file';
    const FILENAME_PREFIX = "@";

    /**
     * @param CurlInterface $curlHandle
     * @param string|array $data
     * @param string $authHeaders
     */
    public function prepare(CurlInterface $curlHandle, $data, $authHeaders = NULL)
    {
        //hardcoded +header Authorization
        $headers = array(self::CONTENT_TYPE_MULTIPART);
        if (is_array($authHeaders))
        {
            $headers = array_merge($headers, $authHeaders);
        }

        if (isset($data[self::FIELD_FILE_NAME]))
        {
            $postFields = array(self::FORM_VARIABLE_FILE => self::FILENAME_PREFIX . $data[self::FIELD_FILE_NAME]);
        }
        else
        {
            $postFields = $data;
        }
        $curlHandle->setOption(CURLOPT_POSTFIELDS, $postFields);
        $curlHandle->setOption(CURLOPT_URL, $data[self::FIELD_HREF]);
        $curlHandle->setOption(CURLOPT_HTTPHEADER, $headers);
    }
}
