<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

trait Service_MspApiClient_MspApiFactoryTrait
{
    /**
     * @param string $url
     * @param string $login
     * @param string $password
     * @param string $instanceId
     * @return Service_MspApiClient_Api
     * @throws \Service_BaseClient_HTTPException
     * @throws Exception
     */
    protected function createMspApiInstance($url, $login, $password, $instanceId = null)
    {
        $apiUri = $url . MSP_API_URI;
        $isCliMode = php_sapi_name() === 'cli';

        $restClient = new Service_BaseClient_RestClient();
        $restClient->setApiUri($apiUri);

        if (!is_null($instanceId)) {
            $cookieFile = DIR_COOKIES . $instanceId . '_' . md5($url . $login);
            $restClient->setCookieFile($cookieFile);
        }

        $store = $isCliMode ? new Session_StoreStub() : null;
        $mspApi = new Service_MspApiClient_Api($restClient, $store);
        $mspApi->setCredentials($login, $password, $url, $isCliMode);
        $mspApi->login();

        return $mspApi;
    }
}