<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_DeleteUser extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT = '/users/%s/?version=%s';
    const HTTP_DELETE_SUCCESS_CODE = 204;
    const OPERATION_FAILED = 'Operation failed';

    /**
     * @param int $userId
     * @param int $version
     */
    public function __construct($userId, $version)
    {

        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $userId, $version);
        $this->_method = self::METHOD_DELETE;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @throws Exception
     * @return Service_MspApiClient_Response_Version
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        if ($httpCode != self::HTTP_DELETE_SUCCESS_CODE)
        {
            throw new Exception(self::OPERATION_FAILED);
        }

        return new Service_MspApiClient_Response_Version($responseBody);
    }
}