<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_Struct_GroupContact
    extends Service_BaseClient_Request_Struct_Updatable
{
    const FIELD_FIRSTNAME = "firstname";
    const FIELD_LASTNAME = "lastname";
    const FIELD_EMAIL = "email";
    const FIELD_ADDRESS_1 = "address1";
    const FIELD_ADDRESS_2 = "address2";
    const FIELD_CITY = "city";
    const FIELD_STATE = "state";
    const FIELD_COUNTRY = "country";
    const FIELD_ZIPCODE = "zipcode";
    const FIELD_PHONE = "phone";

    /** @var string  */
    private $_firstName = "";
    /** @var string  */
    private $_lastName = "";
    /** @var string  */
    private $_email = "";
    /** @var string  */
    private $_address1 = "";
    /** @var string  */
    private $_address2 = "";
    /** @var string  */
    private $_city = "";
    /** @var string  */
    private $_state = "";
    /** @var string  */
    private $_country = "";
    /** @var string  */
    private $_zipCode = "";
    /** @var string  */
    private $_phone = "";

    /**
     * @return array
     */
    public function toArray()
    {
        return array(
            self::FIELD_FIRSTNAME => $this->getFirstName(),
            self::FIELD_LASTNAME => $this->getLastName(),
            self::FIELD_EMAIL => $this->getEmail(),
            self::FIELD_ADDRESS_1 => $this->getAddress1(),
            self::FIELD_ADDRESS_2 => $this->getAddress2(),
            self::FIELD_CITY => $this->getCity(),
            self::FIELD_STATE => $this->getState(),
            self::FIELD_COUNTRY => $this->getCountry(),
            self::FIELD_ZIPCODE => $this->getZipCode(),
            self::FIELD_PHONE => $this->getPhone()
        );
    }

    /**
     * @param string $address1
     */
    public function setAddress1($address1)
    {
        $this->_markFieldAsUpdated(self::FIELD_ADDRESS_1);
        $this->_address1 = $address1;
    }

    /**
     * @return string
     */
    public function getAddress1()
    {
        return $this->_address1;
    }

    /**
     * @param string $address2
     */
    public function setAddress2($address2)
    {
        $this->_markFieldAsUpdated(self::FIELD_ADDRESS_2);
        $this->_address2 = $address2;
    }

    /**
     * @return string
     */
    public function getAddress2()
    {
        return $this->_address2;
    }

    /**
     * @param string $city
     */
    public function setCity($city)
    {
        $this->_markFieldAsUpdated(self::FIELD_CITY);
        $this->_city = $city;
    }

    /**
     * @return string
     */
    public function getCity()
    {
        return $this->_city;
    }

    /**
     * @param string $country
     */
    public function setCountry($country)
    {
        $this->_markFieldAsUpdated(self::FIELD_COUNTRY);
        $this->_country = $country;
    }

    /**
     * @return string
     */
    public function getCountry()
    {
        return $this->_country;
    }

    /**
     * @param string $email
     */
    public function setEmail($email)
    {
        $this->_markFieldAsUpdated(self::FIELD_EMAIL);
        $this->_email = $email;
    }

    /**
     * @return string
     */
    public function getEmail()
    {
        return $this->_email;
    }

    /**
     * @param string $firstName
     */
    public function setFirstName($firstName)
    {
        $this->_markFieldAsUpdated(self::FIELD_FIRSTNAME);
        $this->_firstName = $firstName;
    }

    /**
     * @return string
     */
    public function getFirstName()
    {
        return $this->_firstName;
    }

    /**
     * @param string $lastName
     */
    public function setLastName($lastName)
    {
        $this->_markFieldAsUpdated(self::FIELD_LASTNAME);
        $this->_lastName = $lastName;
    }

    /**
     * @return string
     */
    public function getLastName()
    {
        return $this->_lastName;
    }

    /**
     * @param string $phone
     */
    public function setPhone($phone)
    {
        $this->_markFieldAsUpdated(self::FIELD_PHONE);
        $this->_phone = $phone;
    }

    /**
     * @return string
     */
    public function getPhone()
    {
        return $this->_phone;
    }

    /**
     * @param string $state
     */
    public function setState($state)
    {
        $this->_markFieldAsUpdated(self::FIELD_STATE);
        $this->_state = $state;
    }

    /**
     * @return string
     */
    public function getState()
    {
        return $this->_state;
    }

    /**
     * @param string $zipCode
     */
    public function setZipCode($zipCode)
    {
        $this->_markFieldAsUpdated(self::FIELD_ZIPCODE);
        $this->_zipCode = $zipCode;
    }

    /**
     * @return string
     */
    public function getZipCode()
    {
        return $this->_zipCode;
    }
}