<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

/**
 * @deprecated
 */
class Service_MspApiClient_Response_GetUsageReport extends Service_BaseClient_Response_Base
{
    const PROPERTY_PARAMS = 'params';
    const PROPERTY_TENANTS = 'tenants';

    const PROPERTY_HEADERS_NAME = 'name';
    const PROPERTY_HEADERS_BEGIN_DATE = 'begin_date';
    const PROPERTY_HEADERS_END_DATE = 'end_date';
    const PROPERTY_HEADERS_GENERATION_DATE = 'gen_date';
    const PROPERTY_HEADERS_REPORT_LEVEL = 'report_level';
    const PROPERTY_HEADERS_GROUP_ID = 'group_id';

    const PROPERTY_BODY_STORAGE_ID = 'storage_id';
    const PROPERTY_BODY_STORAGE_NAME = 'storage_name';
    const PROPERTY_BODY_TOTAL_STORAGE = 'total_storage';
    const PROPERTY_BODY_PRODUCTION_STORAGE = 'production_storage';
    const PROPERTY_BODY_PRODUCTION_WORKSTATIONS = 'production_workstations';
    const PROPERTY_BODY_PRODUCTION_SERVERS = 'production_servers';
    const PROPERTY_BODY_PRODUCTION_VMS = 'production_vms';
    const PROPERTY_BODY_PRODUCTION_MAILBOXES = 'production_mailboxes';
    const PROPERTY_BODY_PRODUCTION_MOBILES = 'production_mobiles';
    const PROPERTY_BODY_PRODUCTION_WEBSITES = 'production_websites';
    const PROPERTY_BODY_PRODUCTION_STORAGE_WORKSTATIONS = 'production_storage_workstations';
    const PROPERTY_BODY_GROUP_ID = 'group_id';
    const PROPERTY_BODY_PRODUCTION_STORAGE_ORPHANED = 'production_storage_orphaned';

    /**
     * @param string|null $responseBody
     */
    public function __construct($responseBody = null)
    {
        try {
            $decodedString = gzdecode($responseBody);
            if ($decodedString === false) {
                $decodedString = $responseBody;
            }
        } catch (Exception $e) {
            $decodedString = $responseBody;
        }

        parent::__construct($decodedString);
    }

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_UsageReport
     * @throws Exception
     */
    protected function _init(array $responseData)
    {

        $params = $this->_getProperty(self::PROPERTY_PARAMS, $responseData);
        $headers = $this->fetchHeaders($params);

        $tenants = $this->_getProperty(self::PROPERTY_TENANTS, $responseData);
        $body = array();
        foreach ($tenants as $tenant) {
            $body[] = $this->fetchBodyItem($tenant);
        }

        $report = new Service_MspApiClient_Response_Struct_UsageReport();
        $report->setParams($headers);
        $report->setTenants($body);

        return $report;
    }

    /**
     * @param $tenant
     * @return Service_MspApiClient_Response_Struct_UsageReportBodyItem
     * @throws Exception
     */
    protected function fetchBodyItem($tenant)
    {
        $item = new Service_MspApiClient_Response_Struct_UsageReportBodyItem();
        $item->setGroupId($this->_getProperty(self::PROPERTY_BODY_GROUP_ID, $tenant));
        $item->setStorageId($this->_getProperty(self::PROPERTY_BODY_STORAGE_ID, $tenant));
        $item->setStorageName($this->_getProperty(self::PROPERTY_BODY_STORAGE_NAME, $tenant));
        $item->setTotalStorage((int)$this->_getProperty(self::PROPERTY_BODY_TOTAL_STORAGE, $tenant));
        $item->setProductionStorage((int)$this->_getProperty(self::PROPERTY_BODY_PRODUCTION_STORAGE, $tenant));
        $item->setProductionWorkstations((int)$this->_getProperty(self::PROPERTY_BODY_PRODUCTION_WORKSTATIONS, $tenant));
        $item->setProductionServers((int)$this->_getProperty(self::PROPERTY_BODY_PRODUCTION_SERVERS, $tenant));
        $item->setProductionVms((int)$this->_getProperty(self::PROPERTY_BODY_PRODUCTION_VMS, $tenant));
        $item->setProductionMailboxes((int)$this->_getProperty(self::PROPERTY_BODY_PRODUCTION_MAILBOXES, $tenant));
        $item->setProductionMobiles((int)$this->_getProperty(self::PROPERTY_BODY_PRODUCTION_MOBILES, $tenant));
        $item->setProductionWebsites((int)$this->_getProperty(self::PROPERTY_BODY_PRODUCTION_WEBSITES, $tenant, false));
        $item->setProductionWorkstationsStorage((int)$this->_getProperty(self::PROPERTY_BODY_PRODUCTION_STORAGE_WORKSTATIONS, $tenant));
        $item->setProductionStorageOrphaned((int)$this->_getProperty(self::PROPERTY_BODY_PRODUCTION_STORAGE_ORPHANED, $tenant, false));

        return $item;
    }

    /**
     * @param $params
     * @return Service_MspApiClient_Response_Struct_UsageReportHeaders
     * @throws Exception
     */
    protected function fetchHeaders($params)
    {
        $headers = new Service_MspApiClient_Response_Struct_UsageReportHeaders();
        $headers->setName($this->_getProperty(self::PROPERTY_HEADERS_NAME, $params));
        $headers->setBeginDate($this->_getProperty(self::PROPERTY_HEADERS_BEGIN_DATE, $params));
        $headers->setEndDate($this->_getProperty(self::PROPERTY_HEADERS_END_DATE, $params));
        $headers->setGenerationDate($this->_getProperty(self::PROPERTY_HEADERS_GENERATION_DATE, $params));
        $headers->setReportLevel($this->_getProperty(self::PROPERTY_HEADERS_REPORT_LEVEL, $params));
        $headers->setGroupId($this->_getProperty(self::PROPERTY_HEADERS_GROUP_ID, $params));
        return $headers;
    }
}
