<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
 
class Service_MspApiClient_Response_MigrationUser extends Service_BaseClient_Response_Base
{
    const ID = 'id';
    const LOGIN = 'login';
    const GROUP = 'group';

    /** @var Service_MspApiClient_Response_Struct_FactoryInterface */
    private $_factory;

    /**
     * @param string|null $responseBody
     * @param Service_MspApiClient_Response_Struct_FactoryInterface $factory
     */
    public function __construct($responseBody = NULL, Service_MspApiClient_Response_Struct_FactoryInterface $factory = NULL)
    {
        $this->_factory = is_null($factory) ? new Service_MspApiClient_Response_Struct_Factory() : $factory;
        parent::__construct($responseBody);
    }

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_MigrationUser
     */
    protected function _init(array $responseData)
    {
        $migrationUser = new Service_MspApiClient_Response_Struct_MigrationUser();
        try
        {
            $migrationUser->setId($responseData[self::ID]);
            $migrationUser->setLogin($responseData[self::LOGIN]);
            $migrationUser->setGroup($responseData[self::GROUP]);
        }
        catch (Exception $e)
        {
            Log::getInstance()->error($e->getMessage());
            return null;
        }
        
        return $migrationUser;
    }
}