<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_Api implements Service_OpenApi_ApiInterface
{
    const COMMAND_PEM_GET_ACCOUNT_INFO = 'pem.getAccountInfo';
    const COMMAND_PEM_GET_ACCOUNT_SUBSCRIPTIONS = 'pem.getAccountSubscriptions';
    const COMMAND_PEM_GET_SUBSCRIPTION = 'pem.getSubscription';
    const COMMAND_PEM_ADD_RESOURCE_TYPE = 'pem.addResourceType';
    const COMMAND_PEM_REMOVE_RESOURCE_TYPE = 'pem.removeResourceType';
    const COMMAND_PEM_APS_GET_APPLICATIONS = 'pem.APS.getApplications';
    const COMMAND_PEM_GET_VENDOR_CUSTOMERS = 'pem.getVendorCustomers';
    const COMMAND_PEM_GET_SERVICE_TEMPLATE_LIST = 'pem.getServiceTemplateList';
    const COMMAND_PEM_GET_ACCOUNT_TOKEN = 'pem.APS.getAccountToken';
    const COMMAND_PEM_GET_APPLICATION_INSTANCE_TOKEN = 'pem.APS.getApplicationInstanceToken';
    const COMMAND_PEM_GET_APPLICATION_INSTANCES = 'pem.APS.getApplicationInstances';
    const COMMAND_PEM_GET_APPLICATION_INSTANCE_SETTINGS = 'pem.APS.getApplicationInstanceSettings';
    const COMMAND_PEM_GET_SUBSCRIPTION_APPLICATION_INSTANCES = 'pem.APS.getSubscriptionApplicationInstances';
    const COMMAND_PEM_GET_APPLICATION_INSTANCE_SERVICE_RESOURCE_TYPE = 'pem.APS.getApplicationInstanceServiceResourceTypes';
    const COMMAND_PEM_GET_SERVICE_INSTANCES = 'pem.APS.getServiceInstances';
    const COMMAND_PEM_PROVIDE_APPLICATION_INSTANCE = 'pem.APS.provideApplicationInstance';
    const COMMAND_PEM_ADD_SERVICE_TEMPLATE = 'pem.addServiceTemplate';
    const COMMAND_PEM_ACTIVATE_SERVICE_TEMPLATE = 'pem.activateST';
    const COMMAND_PEM_SET_RT_LIMITS = 'pem.setSTRTLimits';
    const COMMAND_BSS_ADD_SERVICE_PLAN = 'bss.addServicePlan';
    const COMMAND_BSS_CHANGE_MEASUREMENT_UNIT = 'bss.changeMeasurementUnit';
    const COMMAND_BSS_ADD_RESOURCE_CATEGORY = 'bss.addResourceCategory';
    const COMMAND_BSS_ADD_STORE_SCREEN = 'bss.addStoreScreen';
    const COMMAND_BSS_ADD_PURCHASE_SCENARIO = 'bss.addPurchaseScenario';
    const COMMAND_BSS_ADD_PLAN_UPGRADE = 'bss.addPlanUpgrade';
    const OAPI_ACCOUNT_ID = 'account_id';
    const PHONE_TEMPLATE = '{country_code}{area_code}{ext_num}{phone_num}';
    const FIELD_ADDRESS = 'address';
    const FIELD_TECH_CONTACT = 'tech_contact';
    const FIELD_COUNTRY = 'country';
    const FIELD_ZIPCODE = 'zipcode';
    const FIELD_STATE = 'state';
    const FIELD_LAST_NAME = 'last_name';
    const FIELD_FIRST_NAME = 'first_name';
    const FIELD_EMAIL = 'email';
    const FIELD_ADDRESS_2 = 'address2';
    const FIELD_STREET_NAME = 'street_name';
    const FIELD_CITY = 'city';
    const FIELD_PHONE = 'phone';
    const FIELD_COUNTRY_CODE = 'country_code';
    const FIELD_AREA_CODE = 'area_code';
    const FIELD_EXT_NUM = 'ext_num';
    const FIELD_PHONE_NUM = 'phone_num';
    const FIELD_ACCOUNT_ID = 'account_id';
    const FIELD_ACCOUNT_TYPE = 'account_type';
    const FIELD_PARENT_ACCOUNT_ID = 'parent_account_id';
    const FIELD_COMPANY_NAME = 'company_name';
    const FIELD_PERSON = 'person';
    const SUBSCRIPTION_ID = 'subscription_id';
    const GET_RESOURCES = 'get_resources';
    const FIELD_RESOURCEID = 'resourceID';
    const FIELD_MEASUREMENT_UNIT = 'measurementUnit';
    const FIELD_SERVICE_TEMPLATE_ID = 'serviceTemplateId';
    const FIELD_SHORT_DESCRIPTION = 'shortDescription';
    const FIELD_LONG_DESCRIPTION = 'longDescription';
    const FIELD_SALES_CATEGORY = 'salesCategory';
    const FIELD_IMAGE_FILE = 'imageFile';
    const FIELD_PUBLISHED = 'published';
    const FIELD_NOTIFICATION_TEMPLATE = 'notificationTemplate';
    const FIELD_BILL_PERIOD = 'billPeriod';
    const FIELD_BILL_PERIOD_TYPE = 'billPeriodType';
    const FIELD_CHANRGING_TYPE = 'chargingType';
    const FIELD_AUTO_RENEW_TYPE = 'autoRenewType';
    const FIELD_AUTO_ORDER_INTERVAL = 'renewOrderInterval';
    const FIELD_RESOURCE_RATES = 'resourceRates';
    const FIELD_PLAN_PERIODS = 'planPeriods';
    const FIELD_LISTING_PRIORITY = 'listingPriority';
    const FIELD_ID = 'id';
    const FIELD_ORDER_NUMBER = 'orderNum';
    const FIELD_STORE_SCREENS = 'storeScreens';
    const FIELD_SALES_CATEGORIES = 'salesCategories';
    const FIELD_STORE_SCREENS_PARAMETERS = 'storeScreenParam';
    const FIELD_TITLE = 'title';
    const FIELD_STORE_TEMPLATE_ID = 'storeTemplateId';
    const FIELD_SUBSCRIPTION_ID = 'subscription_id';
    const FIELD_AUTO_PROVISIONING = 'auto_provisioning';
    const FIELD_CATEGORY = 'category';
    const FIELD_RESOURCES = 'resources';
    const FIELD_URL_PATH = 'url_path';
    const FIELD_LIMITS = 'limits';
    const FIELD_NAME = 'name';
    const FIELD_ST_ID = 'st_id';
    const FIELD_ST_VERSION = 'st_version';
    const FIELD_OWNER_ID = 'owner_id';
    const FIELD_IS_ACTIVE = 'is_active';
    const FIELD_RESOURCE_TYPES = 'resource_types';
    const FIELD_ACTIVE = 'active';
    const FIELD_VENDOR_ID = 'vendor_id';
    const FIELD_APP_ID = 'app_id';
    const FIELD_APPLICATION_INSTANCE_ID = 'application_instance_id';
    const FIELD_SERVICE_ID = 'service_id';
    const PARAM_APS_APPLICATION_ID = 'aps_application_id';
    const FIELD_APPLICATION_ID = 'application_id';
    const FIELD_RESOURCE_LIMIT = 'resource_limit';
    const FIELD_AUTOPROVIDE_SERVICE = 'autoprovide_service';
    const FIELD_RESOURCE_ID = 'resource_id';
    const FIELD_FROM_PLAN_ID = 'fromPlanId';
    const FIELD_TO_PLAN_ID = 'toPlanId';
    const PARAM_RES_CLASS_NAME = 'resclass_name';
    const PARAM_NAME = 'name';
    const PARAM_DESCR = 'descr';
    const PARAM_ATTRS = 'attrs';
    const PARAM_ACT_PARAMS = 'act_params';
    const PARAM_VAR_NAME = 'var_name';
    const PARAM_VAR_VALUE = 'var_value';
    const VALUE_RESOURCE_UID = 'resource_uid';
    const VALUE_APP_ID = 'app_id';
    const FIELD_RESOURCE_TYPE_ID = 'resource_type_id';
    const PARAM_RT_ID = 'rt_id';
    const RC_SAAS_SERVICE = 'rc.saas.service';
    const RC_SAAS_SERVICE_LINK = 'rc.saas.service.link';
    const RC_SAAS_RESOURCE = 'rc.saas.resource';
    const RC_SAAS_RESOURCE_UNIT = 'rc.saas.resource.unit';
    const EX_MSG_PROPERTY_NOT_FOUND = 'Property with name %s not found';
    const EX_MSG_APPLICATION_NOT_FOUND = 'Application with id "%s" not found';

    const APS_CLASS_NAME_SERVICE_LINK = 'rc.saas.service.link';
    const APS_CLASS_NAME_SERVICE = 'rc.saas.service';

    /** @var Service_OpenApi_Client */
    private $_client;

    /**
     * @param Service_OpenApi_Client $openApiClient
     */
    public function __construct(Service_OpenApi_Client $openApiClient)
    {
        $this->_client = $openApiClient;
    }

    public function getProviderToken()
    {
        return $this->getAccountToken(
            static::PROVIDER_ACCOUNT_ID,
            static::PROVIDER_SUBSCRIPTION_ID
        );
    }

    /**
     * @param int $accountId
     * @return Service_OpenApi_Response_AccountInfo
     */
    public function getAccountInfo($accountId)
    {
        $responseData = $this->_client->call(
            Service_OpenApi_Api::COMMAND_PEM_GET_ACCOUNT_INFO,
            array(self::OAPI_ACCOUNT_ID => $accountId)
        );

        $person = $this->_getResponseField(self::FIELD_PERSON, $responseData);
        $contactData = $this->_getResponseField(self::FIELD_TECH_CONTACT, $responseData);
        $contact = new Service_OpenApi_Response_AccountInfo_Contact(
            $this->_getResponseField(self::FIELD_EMAIL, $contactData),
            $this->_getResponseField(self::FIELD_FIRST_NAME, $contactData),
            $this->_getResponseField(self::FIELD_LAST_NAME, $contactData)
        );
        $addressData = $this->_getResponseField(self::FIELD_ADDRESS, $responseData);
        $address = new Service_OpenApi_Response_AccountInfo_Address(
            $this->_getResponseField(self::FIELD_COUNTRY, $addressData),
            $this->_getResponseField(self::FIELD_ZIPCODE, $addressData),
            $this->_getResponseField(self::FIELD_STATE, $addressData),
            $this->_getResponseField(self::FIELD_CITY, $addressData),
            $this->_getResponseField(self::FIELD_STREET_NAME, $addressData),
            $this->_getResponseField(self::FIELD_ADDRESS_2, $addressData)
        );
        $phone = $this->_getResponseField(self::FIELD_PHONE, $responseData);
        $phoneNumber = strtr(
            self::PHONE_TEMPLATE,
            array(
                '{country_code}' => $this->_getResponseField(self::FIELD_COUNTRY_CODE, $phone),
                '{area_code}' => $this->_getResponseField(self::FIELD_AREA_CODE, $phone),
                '{ext_num}' => $this->_getResponseField(self::FIELD_EXT_NUM, $phone),
                '{phone_num}' => $this->_getResponseField(self::FIELD_PHONE_NUM, $phone),
            )
        );
        return new Service_OpenApi_Response_AccountInfo(
            $this->_getResponseField(self::FIELD_COMPANY_NAME, $person),
            $this->_getResponseField(self::FIELD_ACCOUNT_ID, $responseData),
            $this->_getResponseField(self::FIELD_ACCOUNT_TYPE, $responseData),
            $this->_getResponseField(self::FIELD_PARENT_ACCOUNT_ID, $responseData),
            $phoneNumber,
            $address,
            $contact
        );
    }

    /**
     * @param int $accountId
     * @return array
     */
    public function getAccountSubscription($accountId)
    {
        return $this->_client->call(
            Service_OpenApi_Api::COMMAND_PEM_GET_ACCOUNT_SUBSCRIPTIONS,
            array(self::OAPI_ACCOUNT_ID => $accountId)
        );
    }

    /**
     * @param int $subscriptionId
     * @param bool $getResources
     * @return SubscriptionInfoInterface
     */
    public function getSubscription($subscriptionId, $getResources = true)
    {
        $subscriptionData = $this->_client->call(
            self::COMMAND_PEM_GET_SUBSCRIPTION,
            array(
                self::SUBSCRIPTION_ID => $subscriptionId,
                self::GET_RESOURCES => $getResources
            )
        );
        $resourceTypesData = $this->_getResponseField(self::FIELD_RESOURCE_TYPES, $subscriptionData);
        $resourceTypes = array();
        foreach ($resourceTypesData as $item)
        {
            $resourceTypes[] = new Service_OpenApi_Response_SubscriptionInfo_ResourceType(
                $this->_getResponseField('name', $item),
                $this->_getResponseField('resource_type_id', $item)
            );
        }

        return new Service_OpenApi_Response_SubscriptionInfo(
            $this->_getResponseField(self::FIELD_SUBSCRIPTION_ID, $subscriptionData),
            $this->_getResponseField(self::FIELD_NAME, $subscriptionData),
            $this->_getResponseField(self::FIELD_ST_ID, $subscriptionData),
            $this->_getResponseField(self::FIELD_ST_VERSION, $subscriptionData),
            $this->_getResponseField(self::FIELD_OWNER_ID, $subscriptionData),
            $this->_getResponseField(self::FIELD_IS_ACTIVE, $subscriptionData),
            $resourceTypes
        );
    }

    /**
     * @param string $apsApplicationId
     * @throws Exception
     * @return string
     */
    public function apsGetApplicationId($apsApplicationId)
    {
        $applications = $this->_client->call(
            self::COMMAND_PEM_APS_GET_APPLICATIONS,
            array(
                self::PARAM_APS_APPLICATION_ID => $apsApplicationId
            )
        );

        $application = array_shift($applications);
        if (is_null($application))
        {
            throw new Service_OpenApi_GenericException(sprintf(self::EX_MSG_APPLICATION_NOT_FOUND, $apsApplicationId));
        }

        return $this->_getResponseField(self::FIELD_APPLICATION_ID, $application);
    }

    /**
     * @param string $resClassName
     * @param string $name
     * @param string $description
     * @param array $attributes
     * @param array $parameters
     * @return string
     */
    public function addResourceType($resClassName, $name, $description = null, array $attributes = null, array $parameters = null)
    {
        $requestData = array(
            self::PARAM_RES_CLASS_NAME => (string) $resClassName,
            self::PARAM_NAME           => (string) $name
        );

        if (isset($description))
        {
            $requestData[self::PARAM_DESCR] = $description;
        }

        if (isset($attributes))
        {
            $requestData[self::PARAM_ATTRS] = $attributes;
        }

        if (isset($parameters))
        {
            $requestData[self::PARAM_ACT_PARAMS] = $parameters;
        }

        $responseData = $this->_client->call(
            self::COMMAND_PEM_ADD_RESOURCE_TYPE,
            $requestData
        );

        return $this->_getResponseField(self::FIELD_RESOURCE_TYPE_ID, $responseData);
    }


    /**
     * @param string $name
     * @param int $applicationId
     * @param string $resourceId
     * @param string $description
     * @param array $attributes
     * @return string
     */
    public function addRTServiceLink($name, $applicationId, $resourceId, $description = null, array $attributes = null)
    {
        return $this->addResourceType(self::RC_SAAS_SERVICE_LINK, $name, $description, $attributes, array(
            array(
                self::PARAM_VAR_NAME => self::VALUE_RESOURCE_UID,
                self::PARAM_VAR_VALUE => (string)$resourceId
            ),
            array(
                self::PARAM_VAR_NAME => self::VALUE_APP_ID,
                self::PARAM_VAR_VALUE => (string)$applicationId
            )
        ));
    }

    /**
     * @param int $resourceTypeId
     */
    public function removeResourceType($resourceTypeId)
    {
        $this->_client->call(
            self::COMMAND_PEM_REMOVE_RESOURCE_TYPE,
            array(
                self::PARAM_RT_ID => (int)$resourceTypeId
            )
        );
    }

    /**
     * @param int $providerId
     * @return array of customer IDs
     */
    public function getCustomerIds($providerId)
    {
        $customerIds = $this->_client->call(
            self::COMMAND_PEM_GET_VENDOR_CUSTOMERS,
            array(
                self::FIELD_VENDOR_ID => $providerId
            )
        );

        return $customerIds;
    }

     /**
     * @param int $providerId
     * @return array of templates
     */
    public function getServiceTemplateList($providerId)
    {
        $serviceTemplateList = $this->_client->call(
            self::COMMAND_PEM_GET_SERVICE_TEMPLATE_LIST,
            array(
                self::FIELD_OWNER_ID => $providerId,
                self::FIELD_ACTIVE => true
            )
        );

        return $serviceTemplateList;
    }

    /**
     * @param int $accountId
     * @param int $subscriptionId
     * @return array account token
     */
    public function getAccountToken($accountId, $subscriptionId)
    {
        $accountToken = $this->_client->call(
            self::COMMAND_PEM_GET_ACCOUNT_TOKEN,
            array(
                self::FIELD_ACCOUNT_ID => $accountId,
                self::FIELD_SUBSCRIPTION_ID => $subscriptionId
            )
        );

        return $accountToken;
    }

    /**
     * @param int $applicationInstanceId
     * @return array application instance token
     */
    public function getApplicationInstanceToken($applicationInstanceId)
    {
        return $this->_client->call(
            self::COMMAND_PEM_GET_APPLICATION_INSTANCE_TOKEN,
            array(
                self::FIELD_APPLICATION_INSTANCE_ID => $applicationInstanceId
            )
        );
    }
    
    /**
     * @param string $fieldName
     * @param array $responseData
     * @throws Exception
     * @return array|string
     */
    private function _getResponseField($fieldName, array $responseData)
    {
        if (isset($responseData[$fieldName]))
        {
            return $responseData[$fieldName];
        }
        throw new Service_OpenApi_GenericException(sprintf(self::EX_MSG_PROPERTY_NOT_FOUND, $fieldName));
    }

    /**
     * @param int $applicationId
     * @return array
     */
    public function getApplicationInstances($applicationId)
    {
        $applicationInstances = $this->_client->call(
            self::COMMAND_PEM_GET_APPLICATION_INSTANCES,
            array(
                self::FIELD_APP_ID => $applicationId
            )
        );

        return $applicationInstances;
    }

    /**
     * @param int $applicationInstanceId
     * @return array
     */
    public function getApplicationInstanceSettings($applicationInstanceId)
    {
        $instanceSettings = $this->_client->call(
            self::COMMAND_PEM_GET_APPLICATION_INSTANCE_SETTINGS,
            array(
                self::FIELD_APPLICATION_INSTANCE_ID => $applicationInstanceId
            )
        );

        return $instanceSettings;
    }

    /**
     * @param int $subscriptionId
     * @return array
     */
    public function getSubscriptionApplicationInstances($subscriptionId)
    {
        $instances = $this->_client->call(
            self::COMMAND_PEM_GET_SUBSCRIPTION_APPLICATION_INSTANCES,
            array(
                self::FIELD_SUBSCRIPTION_ID => $subscriptionId
            )
        );

        return $instances;
    }

    /**
     * @param $applicationInstanceId
     * @param $serviceId
     * @return array
     */
    public function getServiceInstances($applicationInstanceId, $serviceId)
    {
        $serviceInstances = $this->_client->call(
            self::COMMAND_PEM_GET_SERVICE_INSTANCES,
            array(
                self::FIELD_APPLICATION_INSTANCE_ID => $applicationInstanceId,
                self::FIELD_SERVICE_ID => $serviceId
            )
        );

        return $serviceInstances;
    }

    /**
     * @param $applicationInstanceId
     * @param $serviceId
     * @return array
     */
    public function getApplicationInstanceServiceResourceTypes($applicationInstanceId, $serviceId = null)
    {
        $instanceSettings = $this->_client->call(
            self::COMMAND_PEM_GET_APPLICATION_INSTANCE_SERVICE_RESOURCE_TYPE,
            array(
                self::FIELD_APPLICATION_INSTANCE_ID => $applicationInstanceId,
                self::FIELD_SERVICE_ID => $serviceId
            )
        );

        return $instanceSettings;
    }

    /**
     * @param $applicationId
     * @param $endpointUrl
     * @param int $subscriptionId
     * @param int $rtId
     * @return array
     */
    public function provideApplicationInstance($applicationId, $endpointUrl, $subscriptionId = 0, $rtId = 0)
    {
        $provideInstanceResult = $this->_client->call(
            self::COMMAND_PEM_PROVIDE_APPLICATION_INSTANCE,
            array(
                self::SUBSCRIPTION_ID => $subscriptionId,
                self::PARAM_RT_ID => $rtId,
                self::FIELD_APP_ID => $applicationId,
                self::FIELD_URL_PATH => $endpointUrl
            )
        );

        return $provideInstanceResult;
    }


    /**
     * @param $name
     * @param $resources
     * @param null $category
     * @param int $ownerId
     * @param bool $autoProvisioning
     * @return array
     */
    public function addServiceTemplate($name, $resources, $category = null, $ownerId = 1, $autoProvisioning = false)
    {
        $attributes = array(
            self::FIELD_OWNER_ID => $ownerId,
            self::FIELD_NAME => $name,
            self::FIELD_RESOURCES => $resources
        );
        if (!is_null($category)) {
            $attributes[self::FIELD_CATEGORY] = $category;
        }

        if ($autoProvisioning) {
            $attributes[self::FIELD_AUTO_PROVISIONING] = $autoProvisioning;
        }
        $serviceTemplate = $this->_client->call(
            self::COMMAND_PEM_ADD_SERVICE_TEMPLATE,
            $attributes
        );

        return $serviceTemplate;
    }


    /**
     * @param $serviceTemplateId
     * @param $limits
     * @return array
     */
    public function setServiceTemplateLimits($serviceTemplateId, $limits)
    {
        $instanceSettings = $this->_client->call(
            self::COMMAND_PEM_SET_RT_LIMITS,
            array(
                self::FIELD_ST_ID => $serviceTemplateId,
                self::FIELD_LIMITS => $limits,
            )
        );

        return $instanceSettings;
    }

    /**
     * @param $serviceTemplateId
     * @return mixed
     */
    public function activateServiceTemplate($serviceTemplateId)
    {
        $activateResult = $this->_client->call(
            self::COMMAND_PEM_ACTIVATE_SERVICE_TEMPLATE,
            array(
                self::FIELD_ST_ID => $serviceTemplateId
            )
        );
        return $activateResult;
    }

    /**
     * @param $applicationName
     * @param $applicationResourceId
     * @param $applicationId
     * @return string
     */
    public function addApplicationInstance($applicationName, $applicationResourceId, $applicationId)
    {
        $activateParameters = array(
            array(
                self::PARAM_VAR_NAME => self::VALUE_RESOURCE_UID,
                self::PARAM_VAR_VALUE => $applicationResourceId
            ),
            array(
                self::PARAM_VAR_NAME => self::VALUE_APP_ID,
                self::PARAM_VAR_VALUE => (string)$applicationId
            ),
        );

        $applicationTypeId = $this->addResourceType(
            self::APS_CLASS_NAME_SERVICE_LINK,
            $applicationName,
            null,
            null,
            $activateParameters
        );

        return $applicationTypeId;
    }

    /**
     * @param $name
     * @param $resources
     * @param null $category
     * @return mixed
     */
    public function addActivatedServiceTemplate($name, $resources, $category = null)
    {
        $types = array();
        $limits = array();
        foreach ($resources as $type => $resource) {
            $types[] = array(self::FIELD_RESOURCE_TYPE_ID => $type);
            $limits[] = array(
                self::FIELD_RESOURCE_ID => $type,
                self::FIELD_RESOURCE_LIMIT => $resource
            );
        }

        $serviceTemplate = $this->addServiceTemplate($name, $types, $category);
        $serviceTemplateId = $serviceTemplate[self::FIELD_ST_ID];

        $this->setServiceTemplateLimits($serviceTemplateId, $limits);
        $this->activateServiceTemplate($serviceTemplateId);

        return $serviceTemplateId;
    }

    /**
     * @param $applicationId
     * @param $name
     * @param $type
     * @param $autoprovide
     * @return string
     */
    public function addServiceType($applicationId, $name, $type, $autoprovide)
    {
        $attributes = array(
            array(
                self::PARAM_VAR_NAME => self::FIELD_SERVICE_ID,
                self::PARAM_VAR_VALUE => $type
            ),
            array(
                self::PARAM_VAR_NAME => self::VALUE_APP_ID,
                self::PARAM_VAR_VALUE => (string)$applicationId
            ),
            array(
                self::PARAM_VAR_NAME => self::FIELD_AUTOPROVIDE_SERVICE,
                self::PARAM_VAR_VALUE => $autoprovide ? "1" : "0"
            ),
        );
        $resourceId = $this->addResourceType(self::APS_CLASS_NAME_SERVICE, $name, null, null, $attributes);
        return $resourceId;
    }

    /**
     * @param $resourceId
     * @param $unit
     * @return array
     */
    public function changeMeasurementUnit($resourceId, $unit)
    {
        $changeMeasurementResult = $this->_client->call(
            self::COMMAND_BSS_CHANGE_MEASUREMENT_UNIT,
            array(
                self::FIELD_RESOURCEID => $resourceId,
                self::FIELD_MEASUREMENT_UNIT => $unit
            )
        );
        return $changeMeasurementResult;
    }

    /**
     * @param $name
     * @return array
     */
    public function addResourceCategory($name)
    {
        $resourceCategory = $this->_client->call(
            self::COMMAND_BSS_ADD_RESOURCE_CATEGORY,
            array(
                self::FIELD_NAME => $name,
            )
        );
        return $resourceCategory;
    }

    /**
     * @param $id
     * @param $storeTemplateId
     * @param $title
     * @param $storeScreenParams
     * @param $salesCategories
     * @return array
     */
    public function addStoreScreen($id, $storeTemplateId, $title, $storeScreenParams, $salesCategories)
    {
        $storeScreen = $this->_client->call(
            self::COMMAND_BSS_ADD_STORE_SCREEN,
            array(
                self::FIELD_ID => $id,
                self::FIELD_STORE_TEMPLATE_ID => $storeTemplateId,
                self::FIELD_TITLE => $title,
                self::FIELD_STORE_SCREENS_PARAMETERS => $storeScreenParams,
                self::FIELD_SALES_CATEGORIES => $salesCategories,
            )
        );

        return $storeScreen;
    }

    /**
     * @param $id
     * @param $name
     * @param $orderNumber
     * @param $iconPath
     * @param $storeScreens
     * @return array
     */
    public function addPurchaseScenario($id, $name, $orderNumber, $iconPath, $storeScreens)
    {
        $scenario = $this->_client->call(
            self::COMMAND_BSS_ADD_PURCHASE_SCENARIO,
            array(
                self::FIELD_ID => $id,
                self::FIELD_NAME => $name,
                self::FIELD_ORDER_NUMBER => $orderNumber,
                self::FIELD_IMAGE_FILE => $iconPath,
                self::FIELD_STORE_SCREENS => $storeScreens
            )
        );

        return $scenario;
    }

    /**
     * @param $name
     * @param $serviceTemplateId
     * @param $shortDescription
     * @param $longDescription
     * @param $salesCategory
     * @param $imageFile
     * @param $published
     * @param $notificationTemplate
     * @param $billPeriod
     * @param $billPeriodType
     * @param $chargingType
     * @param $autoRenewType
     * @param $renewOrderInterval
     * @param $resourceRates
     * @param $planPeriods
     * @param $listingPriority
     * @return array
     */
    public function addServicePlan(
        $name,
        $serviceTemplateId,
        $shortDescription,
        $longDescription,
        $salesCategory,
        $imageFile,
        $published,
        $notificationTemplate,
        $billPeriod,
        $billPeriodType,
        $chargingType,
        $autoRenewType,
        $renewOrderInterval,
        $resourceRates,
        $planPeriods,
        $listingPriority
    ) {
        $plan = $this->_client->call(
            self::COMMAND_BSS_ADD_SERVICE_PLAN,
            array(
                self::FIELD_NAME => $name,
                self::FIELD_SERVICE_TEMPLATE_ID => $serviceTemplateId,
                self::FIELD_SHORT_DESCRIPTION => $shortDescription,
                self::FIELD_LONG_DESCRIPTION => $longDescription,
                self::FIELD_SALES_CATEGORY => $salesCategory,
                self::FIELD_IMAGE_FILE => $imageFile,
                self::FIELD_PUBLISHED => $published,
                self::FIELD_NOTIFICATION_TEMPLATE => $notificationTemplate,
                self::FIELD_BILL_PERIOD => $billPeriod,
                self::FIELD_BILL_PERIOD_TYPE => $billPeriodType,
                self::FIELD_CHANRGING_TYPE => $chargingType,
                self::FIELD_AUTO_RENEW_TYPE => $autoRenewType,
                self::FIELD_AUTO_ORDER_INTERVAL => $renewOrderInterval,
                self::FIELD_RESOURCE_RATES => $resourceRates,
                self::FIELD_PLAN_PERIODS => $planPeriods,
                self::FIELD_LISTING_PRIORITY => $listingPriority,
            )
        );

        return $plan;
    }

    public function addPlanUpgrade($fromPlanId, $toPlanId)
    {
        $result = $this->_client->call(
            self::COMMAND_BSS_ADD_PLAN_UPGRADE,
            array(
                self::FIELD_FROM_PLAN_ID => $fromPlanId,
                self::FIELD_TO_PLAN_ID => $toPlanId
            )
        );

        return $result;
    }
}
