<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Request_GetAvailablePlanList extends Service_PbaApi_Client_Request
{
    const METHOD = 'PlanListAvailableGet_API';

    /**
     * Method returns the list of published service plans of specified plan category.
     *
     * @param int $accountId account ID of plan category owner
     * @param string $stType name of service gate service plans are provisioned through: PEMGATE, DOMAINGATE, DUMMYGATE, etc.
     * @param int $planCategoryId plan category ID
     * @param int $sortNo parameter defines how output data is sorted:
     *    "1" - the output is sorted by plan ID in ascending order,
     *    "2" - by plan name in ascending order, etc. Negative value makes output sorted in descending order.
 * @return mixed
     * @throws Service_PbaApi_Api_Exception
     */
    public function __construct($accountId, $stType, $planCategoryId, $sortNo)
    {
        parent::__construct(self::METHOD, array(
            (int)$accountId,
            (string) $stType,
            (int) $planCategoryId,
            (int) $sortNo
        ));
    }

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_GetAvailablePlanList
     */
    public function getExpectedResponse(array $responseArray = NULL)
    {
        return new Service_PbaApi_Api_Response_GetAvailablePlanList($responseArray);
    }
}
