<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Request_GetSubscriptionsListByOrder extends Service_PbaApi_Client_Request
{
    const METHOD = 'GetSubscriptionsListByOrder_API';

    /**
     * Service_PbaApi_Api_Request_GetSubscriptionsListByOrder constructor.
     * @param string $orderId
     * @param int $sortNo
     */
    public function __construct($orderId, $sortNo = 0)
    {
        parent::__construct(self::METHOD, array(
            (int) $orderId,
            (int) $sortNo
        ));
    }

    /**
     * Method returns the list of subscriptions for provisioning items of the specified sales order.
     *
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_GetSubscriptionResourcesList
     */
    public function getExpectedResponse(array $responseArray = null)
    {
        return new Service_PbaApi_Api_Response_GetSubscriptionsListByOrder($responseArray);
    }
}
