<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Request_UpdateSubscriptionStatus extends Service_PbaApi_Client_Request
{
    const METHOD = 'SubscriptionStatusUpdate_API';

    /**
     * @param int $subscriptionId
     * @param int $status
     * @param int $serviceStatus
     */
    public function __construct($subscriptionId, $status, $serviceStatus)
    {
        parent::__construct(self::METHOD, array(
            (int)$subscriptionId,
            (int)$status,
            (int)$serviceStatus
        ));
    }

    /**
     * Method returns status of changed subscription.
     *
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_UpdateSubscriptionStatus
     */
    public function getExpectedResponse(array $responseArray = NULL)
    {
        return new Service_PbaApi_Api_Response_UpdateSubscriptionStatus($responseArray);
    }
}
