<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetCustomerSubscriptionList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_CustomerSubscriptionListItem[]
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $listData = $this->_getProperty(0, $responseArray);

        $list = array();
        foreach ($listData as $itemData) {
            $list[] = $this->initListItem($itemData);
        }

        return $list;
    }

    /**
     * @param $subscriptionData
     * @return Service_PbaApi_Api_Response_Struct_CustomerSubscriptionListItem
     */
    private function initListItem($subscriptionData)
    {
        $subscription = new Service_PbaApi_Api_Response_Struct_CustomerSubscriptionListItem();
        $subscription->setSubscriptionId($this->_getProperty(0, $subscriptionData));
        $subscription->setSubscriptionName($this->_getProperty(1, $subscriptionData));
        $subscription->setPlanId($this->_getProperty(2, $subscriptionData));
        $subscription->setPlanName($this->_getProperty(3, $subscriptionData));
        $subscription->setPlanPeriodId($this->_getProperty(4, $subscriptionData));
        $subscription->setPeriod($this->_getProperty(5, $subscriptionData));
        $subscription->setPeriodType($this->_getProperty(6, $subscriptionData));
        $subscription->setStartDate($this->_getProperty(7, $subscriptionData));
        $subscription->setExpirationDate($this->_getProperty(8, $subscriptionData));
        $subscription->setStatus($this->_getProperty(9, $subscriptionData));
        $subscription->setServiceStatus($this->_getProperty(10, $subscriptionData));
        $subscription->setContainerName($this->_getProperty(11, $subscriptionData));

        return $subscription;
    }
}
