<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetIncludedResources extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result for operation GetIncludedResources';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $response = $this->_getProperty(0, $responseArray);
        $resources = array();
        foreach ($response as $item) {
            $resource = new Service_PbaApi_Api_Response_Struct_GetIncludedResources();
            $resource->setResourceId($this->_getProperty(0, $item));
            $resource->setIncludedResourceId($this->_getProperty(1, $item));
            $resource->setIncludedResourceName($this->_getProperty(2, $item));
            $resource->setMultiplier($this->_getProperty(3, $item));
            $resource->setIncludedResourceMeasurementUnitName($this->_getProperty(4, $item));
            $resources[] = $resource;
        }

        return $resources;
    }
}
