<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetOrder extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result for operation GetOrder_API';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $data = $this->_getProperty(0, $responseArray);

        /*
         * Warning!
         * Error in the BA-API description
         * To add new fields very carefully
         */

        $order = new Service_PbaApi_Api_Response_Struct_GetOrder();
        $order->setOrderID($this->_getProperty(0, $data));
        $order->setOrderNumber($this->_getProperty(1, $data));
        $order->setVendorAccountID($this->_getProperty(2, $data));
        $order->setCustomerAccountID($this->_getProperty(3, $data));
        $order->setOrderStatusID($this->_getProperty(4, $data));
        $order->setOrderTypeID($this->_getProperty(5, $data));
        $order->setCreationTime($this->_getProperty(6, $data));
        $order->setOrderDate($this->_getProperty(7, $data));
        $order->setTotal($this->_getProperty(8, $data));
        $order->setTaxTotal($this->_getProperty(9, $data));
        $order->setDiscountTotal($this->_getProperty(10, $data));
        $order->setMerchTotal($this->_getProperty(11, $data));
        $order->setComments($this->_getProperty(12, $data));
        $order->setExpirationDate($this->_getProperty(13, $data));
        $order->setPromoCode($this->_getProperty(14, $data));
        $order->setSalesBranchID($this->_getProperty(15, $data));
        $order->setSalesPersonID($this->_getProperty(16, $data));
        $order->setCurrencyID($this->_getProperty(17, $data));
        $order->setCompletedDate($this->_getProperty(18, $data, false));
        return $order;
    }
}
