<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanRateList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $listData = $this->_getProperty(0, $responseArray);

        $list = array();
        foreach ($listData as $itemData) {
            $item = new Service_PbaApi_Api_Response_Struct_PlanRateListItem();
            $item->setResourceRateId($this->_getProperty(0, $itemData));
            $item->setResourceRateName($this->_getProperty(1, $itemData));
            $item->setDescription($this->_getProperty(2, $itemData));
            $item->setIncludedValue($this->_getProperty(3, $itemData));
            $item->setUpperLimit($this->_getProperty(4, $itemData));
            $item->setLowerLimit($this->_getProperty(5, $itemData));
            $item->setUnitOfMeasure($this->_getProperty(6, $itemData));
            $item->setSetupFee($this->_getProperty(7, $itemData));
            $item->setRecurringFee($this->_getProperty(8, $itemData));
            $item->setMeasurable($this->_getProperty(9, $itemData));
            $item->setResourceId($this->_getProperty(10, $itemData));
            $item->setSetupFeeDescription($this->_getProperty(11, $itemData));
            $item->setRecurrFeeDescription($this->_getProperty(12, $itemData));
            $item->setIsVisible($this->_getProperty(13, $itemData));
            $item->setIsMain($this->_getProperty(14, $itemData));
            $item->setStoreText($this->_getProperty(15, $itemData));
            $item->setIsSFperUnit($this->_getProperty(16, $itemData));
            $item->setIsRFperUnit($this->_getProperty(17, $itemData));
            $item->setIsSFforUpgrade($this->_getProperty(18, $itemData));
            $item->setStorePriceText($this->_getProperty(19, $itemData));
            $item->setResourceCategoryId($this->_getProperty(20, $itemData));
            $item->setSortOrder($this->_getProperty(21, $itemData));
            $item->setRadioGroupName($this->_getProperty(22, $itemData));
            $item->setParentResourceName($this->_getProperty(23, $itemData));
            $item->setOveruseFeeDescription($this->_getProperty(24, $itemData));
            $item->setOveruseFee($this->_getProperty(25, $itemData));
            $item->setIsOveruseFeeTiered($this->_getProperty(26, $itemData));
            $item->setIsRecurringFeeTiered($this->_getProperty(27, $itemData));
            $item->setIsSetupFeeTiered($this->_getProperty(28, $itemData));
            $list[] = $item;
        }
        return $list;
    }
}
