<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_Struct_PlanDetails
{
    /**
     * Requested service plan ID;
     * @var int
     */
    private $planId;

    /**
     * Service plan name;
     * @var string
     */
    private $name;

    /**
     * ID of the plan category assigned to the requested service plan;
     * @var int
     */
    private $categoryId;

    /**
     * ID of the default provider's currency;
     * @var string
     */
    private $resourceCurrencyId;

    /**
     * Requested service plan short description;
     * @var string
     */
    private $shortDescription;

    /**
     * Requested service plan long description.
     * @var string
     */
    private $longDescription;

    /**
     * Type of service. Identified by name of gate service is provisioned through (DOMAINGATE, PEMGATE, etc);
     * @var string
     */
    private $gateName;

    /**
     * ID of the unique group assigned to the requested service plan.
     * @var int
     */
    private $groupId;

    /**
     * Signifies whether parent subscription is required for this type of service (0 - No, 1 - Yes).
     * Some domain subscriptions require hosting subscription to be specified as parent one;
     * @var int
     */
    private $isParentRequired;

    /**
     * Signifies how recurring fee is charged for subscription
     * (10 - before billing period; 20 - after billing period; 30 - before subscription period; 40 - at the end of month);
     * @var int
     */
    private $recurringType;

    /**
     * Subscription billing period type
     * (4 - monthly on statement cycle date, 2 - fixed number of months, 3 - fixed number of years);
     * @var int
     */
    private $billingPeriodType;

    /**
     * Subscription billing period duration
     * (if BillingPeriodType=2 and BillingPeriod=1, subscription billing period is 1 month);
     * @var int
     */
    private $billingPeriod;

    /**
     * Signifies the priority in which the service plan is shown among other ones of the same sales category in the online store.
     * The highest priority is 1, thus, service plan with such a priority is shown in the topmost left position in the online store;
     * @var int
     */
    private $showPriority;

    /**
     * ID of the subscription period that is automatically selected when customer orders the plan in online store.
     * @var int
     */
    private $defaultPlanPeriodId;

    /**
     * Signifies whether services of this plan are sold without subscription creation (0 - No, 1 - Yes),
     * namely whether the plan is one time fee one.
     * @var int
     */
    private $isOTFI;

    /**
     * ID of the image blob document in a special storage (reference to an image loaded for a service plan).
     * @var string
     */
    private $documentId;

    /**
     * @return int
     */
    public function getPlanId()
    {
        return $this->planId;
    }

    /**
     * @param int $planId
     */
    public function setPlanId($planId)
    {
        $this->planId = $planId;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return int
     */
    public function getCategoryId()
    {
        return $this->categoryId;
    }

    /**
     * @param int $categoryId
     */
    public function setCategoryId($categoryId)
    {
        $this->categoryId = $categoryId;
    }

    /**
     * @return string
     */
    public function getResourceCurrencyId()
    {
        return $this->resourceCurrencyId;
    }

    /**
     * @param string $resourceCurrencyId
     */
    public function setResourceCurrencyId($resourceCurrencyId)
    {
        $this->resourceCurrencyId = $resourceCurrencyId;
    }

    /**
     * @return string
     */
    public function getShortDescription()
    {
        return $this->shortDescription;
    }

    /**
     * @param string $shortDescription
     */
    public function setShortDescription($shortDescription)
    {
        $this->shortDescription = $shortDescription;
    }

    /**
     * @return string
     */
    public function getLongDescription()
    {
        return $this->longDescription;
    }

    /**
     * @param string $longDescription
     */
    public function setLongDescription($longDescription)
    {
        $this->longDescription = $longDescription;
    }

    /**
     * @return string
     */
    public function getGateName()
    {
        return $this->gateName;
    }

    /**
     * @param string $gateName
     */
    public function setGateName($gateName)
    {
        $this->gateName = $gateName;
    }

    /**
     * @return int
     */
    public function getGroupId()
    {
        return $this->groupId;
    }

    /**
     * @param int $groupId
     */
    public function setGroupId($groupId)
    {
        $this->groupId = $groupId;
    }

    /**
     * @return int
     */
    public function getIsParentRequired()
    {
        return $this->isParentRequired;
    }

    /**
     * @param int $isParentRequired
     */
    public function setIsParentRequired($isParentRequired)
    {
        $this->isParentRequired = $isParentRequired;
    }

    /**
     * @return int
     */
    public function getRecurringType()
    {
        return $this->recurringType;
    }

    /**
     * @param int $recurringType
     */
    public function setRecurringType($recurringType)
    {
        $this->recurringType = $recurringType;
    }

    /**
     * @return int
     */
    public function getBillingPeriodType()
    {
        return $this->billingPeriodType;
    }

    /**
     * @param int $billingPeriodType
     */
    public function setBillingPeriodType($billingPeriodType)
    {
        $this->billingPeriodType = $billingPeriodType;
    }

    /**
     * @return int
     */
    public function getBillingPeriod()
    {
        return $this->billingPeriod;
    }

    /**
     * @param int $billingPeriod
     */
    public function setBillingPeriod($billingPeriod)
    {
        $this->billingPeriod = $billingPeriod;
    }

    /**
     * @return int
     */
    public function getShowPriority()
    {
        return $this->showPriority;
    }

    /**
     * @param int $showPriority
     */
    public function setShowPriority($showPriority)
    {
        $this->showPriority = $showPriority;
    }

    /**
     * @return int
     */
    public function getDefaultPlanPeriodId()
    {
        return $this->defaultPlanPeriodId;
    }

    /**
     * @param int $defaultPlanPeriodId
     */
    public function setDefaultPlanPeriodId($defaultPlanPeriodId)
    {
        $this->defaultPlanPeriodId = $defaultPlanPeriodId;
    }

    /**
     * @return int
     */
    public function getIsOTFI()
    {
        return $this->isOTFI;
    }

    /**
     * @param int $isOTFI
     */
    public function setIsOTFI($isOTFI)
    {
        $this->isOTFI = $isOTFI;
    }

    /**
     * @return string
     */
    public function getDocumentId()
    {
        return $this->documentId;
    }

    /**
     * @param string $documentId
     */
    public function setDocumentId($documentId)
    {
        $this->documentId = $documentId;
    }
}
