<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\Config;

use Acronis\App\Services\FactoryInterface;
use Symfony\Component\Config\Definition\Processor as ConfigProcessor;
use Symfony\Component\Yaml\Yaml;

class ConfigFactory implements FactoryInterface
{
    const NAME = 'config';

    /**
     * @return ConfigAccessor
     */
    public function createInstance()
    {
        $configData = Yaml::parseFile(APP_CONFIG_FILE);
        $processor = new ConfigProcessor();
        $configuration = new ConfigSchema();
        $configData = $processor->processConfiguration(
            $configuration,
            [$configData]
        );

        return new ConfigAccessor($configData);
    }
}