<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\Logger;

use APS\LoggerInterface;
use Monolog\Logger;

class ApsLoggerAdapter implements LoggerInterface
{
    use LoggerAwareTrait;

    public function trace($message)
    {
        $this->log(Logger::DEBUG, $message);
    }

    public function debug($message)
    {
        $this->log(Logger::DEBUG, $message);
    }

    public function info($message)
    {
        $this->log(Logger::INFO, $message);
    }

    public function error($message)
    {
        $this->log(Logger::ERROR, $message);
    }

    public function fatal($message)
    {
        $this->log(Logger::EMERGENCY, $message);
    }

    private function log($level, $message)
    {
        $caller = debug_backtrace();
        $zeroFrame = $caller[1];
        $this->getLogger()->log(
            $level,
            'aps-php-runtime: ' . $message,
            [
                'request_id' => \Log::getRequestId(),
                'file' => $zeroFrame['file'],
                'line' => $zeroFrame['line'],
            ]
        );
    }
}
