<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

/**
 * It's a tool to test generation of billing orders/
 * The script sets up property startProductionTime for tenant
 * Place the script into /var/www/html/backupservice
 *
 * Usage: php setupStartProductionTime.php [INSTANCE ID] [APS INSTANCE ID] [SUBSCRIPTION ID] [DATE]
 *
 * Example: php setupStartProductionTime.php 11 7b0c7264-bd31-4aa1-b670-61c568547e53 1006819 13.10.2016
 */

require_once(__DIR__ . "/../app/bootstrap.php");

chdir(DIR_ROOT);
define('APS_RUNTIME_HOME', DIR_ROOT);
define('APS_RUNTIME_NO_PROCESS', true);

$instanceId = $argv[1];
$subscriptionId = $argv[3];
$date = new DateTime();
$date->setTimestamp(strtotime($argv[4]));

$_SERVER['HTTP_APS_INSTANCE_ID'] = $argv[2];
$openApiClient = new Service_OpenApi_Client(OPEN_API_URI);

echo "Getting a token...\n";
$token = $openApiClient->call('pem.APS.getApplicationInstanceToken', array(
    'application_instance_id' => (int)$instanceId
));

echo "Initial APS controller...\n";
$apsc = new \APS\ControllerProxy($token['controller_uri'], null, $token['aps_token']);
APS\Request::setController($apsc);

$resources = $apsc->getResources("implementing(".\APS\TypeLibrary::getTypeByServiceId('tenant')."),eq(subscriptionId,$subscriptionId)");
if (!count($resources)) {
    echo "There is no subscription $subscriptionId\n";
    exit;
}

$resource = $resources[0];
$resource->startProductionTime = $date->getTimestamp();

$res = $apsc->updateResource($resource);
print_r($res);
echo "startProductionTime was successfully upgraded for subscription $subscriptionId\n";