<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

/**
 * Place the script into /var/www/html/backupservice/tools
 * Usage: php updateSubscriptionGroup.php [APS INSTANCE ID] [SUBSCRIPTION ID] [GROUP ID]
 * Example: php setupStartProductionTime.php 7b0c7264-bd31-4aa1-b670-61c568547e53 1006819 431123
 */

require_once(__DIR__ . "/../app/bootstrap.php");

chdir(DIR_ROOT);
define('APS_RUNTIME_HOME', DIR_ROOT);
define('APS_RUNTIME_NO_PROCESS', true);

if (!isset($argv[1], $argv[2], $argv[3])) {
    echo <<<TEXT
Please place the script into /var/www/html/backupservice/tools and specify all script arguments
Usage: php updateSubscriptionGroup.php [APS INSTANCE ID] [SUBSCRIPTION ID] [GROUP ID]
Example: php setupStartProductionTime.php 7b0c7264-bd31-4aa1-b670-61c568547e53 1006819 431123
TEXT;
    echo "\n";
    exit(1);
}

$instanceId = $argv[1];
$subscriptionId = (int) $argv[2];
$groupId = (int) $argv[3];

$_SERVER['HTTP_APS_INSTANCE_ID'] = $instanceId;

echo "Initial APS controller...\n";
$apsc = new \APS\ControllerProxy('https://'.OPEN_API_URI.':6308/');
APS\Request::setController($apsc);

$resources = $apsc->getResources("implementing(".\APS\TypeLibrary::getTypeByServiceId('tenant')."),eq(subscriptionId,$subscriptionId)");
if (!count($resources)) {
    echo "There is no subscription with id $subscriptionId\n";
    exit;
}

$resource = $resources[0];
$resource->mspGroupId = $groupId;

$res = $apsc->updateResource($resource);
print_r($res);
echo "Group was successfully changed to $groupId for the subscription $subscriptionId\n";