# Acronis\Cloud\Client\SearchApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getSearch**](SearchApi.md#getSearch) | **GET** /search | Search


# **getSearch**
> \Acronis\Cloud\Client\Model\Search\Search getSearch($tenant, $text, $limit)

Search

Search for tenants and users. Tenants are searched by name, custom ID, first, last names and emails from contact info. Users are searched by login, email, first and last names. Search is case-insensitive.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\SearchApi();
$tenant = "tenant_example"; // string | Search in this tenant and down by hierarchy
$text = "text_example"; // string | Search in all available properties for supplied text
$limit = 1.2; // double | Limit number of found objects. Default = 10

try {
    $result = $api_instance->getSearch($tenant, $text, $limit);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling SearchApi->getSearch: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenant** | **string**| Search in this tenant and down by hierarchy |
 **text** | **string**| Search in all available properties for supplied text |
 **limit** | **double**| Limit number of found objects. Default &#x3D; 10 | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Search\Search**](../Model/Search/Search.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

