<?php
/**
 * TenantPostSettings
 *
 * PHP version 5
 *
 * @category Class
 * @package  Acronis\Cloud\Client
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * REST API v2 description for Multi-service Portal
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Acronis\Cloud\Client\Model\Tenants;

use Acronis\Cloud\Client\BaseModel;
/**
 * TenantPostSettings Class Doc Comment
 *
 * @category    Class
 * @package     Acronis\Cloud\Client
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class TenantPostSettings extends BaseModel
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'Tenants\TenantPostSettings';

    /**
     * Array of property to type mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerTypes()
    {
        return [
            'enhanced_security' => 'bool'
        ];
    }


    /**
     * Array of property to format mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerFormats()
    {
        return [
            'enhanced_security' => null
        ];
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @return array
     */
    public static function attributeMap()
    {
        return [
            'enhanced_security' => 'enhanced_security'
        ];
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @return array
     */
    public static function setters()
    {
        return [
            'enhanced_security' => 'setEnhancedSecurity'
        ];
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @return array
     */
    public static function getters()
    {
        return [
            'enhanced_security' => 'getEnhancedSecurity'
        ];
    }

    /**
     * Array of attributes to checkers functions (for deserialization of responses)
     * @return array
     */
    public static function checkers()
    {
        return [
            'enhanced_security' => 'hasEnhancedSecurity'
        ];
    }

    /**
     * Array of attributes to validators functions (for deserialization of responses)
     * @return array
     */
    public static function validators() {
        return [
            'enhanced_security' => 'validateEnhancedSecurity'
        ];
    }

    

    

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        if (!empty($this->validateEnhancedSecurity())) {
            $invalid_properties[] = $this->validateEnhancedSecurity();
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        if (!empty($this->validateEnhancedSecurity())) {
            return false;
        }
        return true;
    }


    /**
     * Gets enhanced_security
     * @return bool
     */
    public function getEnhancedSecurity()
    {
        return $this->offsetGet('enhanced_security');
    }

    /**
     * Checks enhanced_security
     * @return boolean
     */
    public function hasEnhancedSecurity()
    {
        return $this->offsetExists('enhanced_security');
    }

    /**
     * Sets enhanced_security
     * @param bool $enhancedSecurity With this mode, only encrypted backups are allowed.
     * The encryption password must be set on the protected device and without it, backups will fail.
     * All operations that require providing the encryption password to a cloud service are
     * not available in this mode. Enhanced security mode cannot be disabled after
     * the tenant is created.
     *
     * @return $this
     */
    public function setEnhancedSecurity($enhancedSecurity)
    {
        $this->offsetSet('enhanced_security', $enhancedSecurity);

        return $this;
    }

    /**
     * Unset enhanced_security
     */
    public function unsetEnhancedSecurity() {
        $this->offsetUnset('enhanced_security');
    }

    /**
     * Valid enhanced_security
     * @return array|boolean
     */
    public function validateEnhancedSecurity()
    {
        if (!$this->offsetExists('enhanced_security')) {
            return "Property 'enhanced_security' was not initialized.";
        }
        return false;
    }

}


