<?php
/**
 * SetupResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  Acronis\Cloud\Client
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * REST API v2 description for Multi-service Portal
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Acronis\Cloud\Client\Model\Totp;

use Acronis\Cloud\Client\BaseModel;
/**
 * SetupResponse Class Doc Comment
 *
 * @category    Class
 * @package     Acronis\Cloud\Client
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class SetupResponse extends BaseModel 
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'Totp\SetupResponse';

    /**
     * Array of property to type mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerTypes()
    {
        return [
            'barcode' => 'string',
            'url' => 'string'
        ];
    }


    /**
     * Array of property to format mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerFormats()
    {
        return [
            'barcode' => null,
            'url' => null
        ];
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @return array
     */
    public static function attributeMap()
    {
        return [
            'barcode' => 'barcode',
            'url' => 'url'
        ];
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @return array
     */
    public static function setters()
    {
        return [
            'barcode' => 'setBarcode',
            'url' => 'setUrl'
        ];
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @return array
     */
    public static function getters()
    {
        return [
            'barcode' => 'getBarcode',
            'url' => 'getUrl'
        ];
    }

    /**
     * Array of attributes to checkers functions (for deserialization of responses)
     * @return array
     */
    public static function checkers()
    {
        return [
            'barcode' => 'hasBarcode',
            'url' => 'hasUrl'
        ];
    }

    /**
     * Array of attributes to validators functions (for deserialization of responses)
     * @return array
     */
    public static function validators() {
        return [
            'barcode' => 'validateBarcode',
            'url' => 'validateUrl'
        ];
    }

    

    

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        if (!empty($this->validateBarcode())) {
            $invalid_properties[] = $this->validateBarcode();
        }
        if (!empty($this->validateUrl())) {
            $invalid_properties[] = $this->validateUrl();
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        if (!empty($this->validateBarcode())) {
            return false;
        }
        if (!empty($this->validateUrl())) {
            return false;
        }
        return true;
    }


    /**
     * Gets barcode
     * @return string
     */
    public function getBarcode()
    {
        return $this->offsetGet('barcode');
    }

    /**
     * Checks barcode
     * @return boolean
     */
    public function hasBarcode()
    {
        return $this->offsetExists('barcode');
    }

    /**
     * Sets barcode
     * @param string $barcode QR code, base64-formatted PNG bytes
     * @return $this
     */
    public function setBarcode($barcode)
    {
        $this->offsetSet('barcode', $barcode);

        return $this;
    }

    /**
     * Unset barcode
     */
    public function unsetBarcode() {
        $this->offsetUnset('barcode');
    }

    /**
     * Valid barcode
     * @return array|boolean
     */
    public function validateBarcode()
    {
        if (!$this->offsetExists('barcode')) {
            return "Property 'barcode' was not initialized.";
        }
        return false;
    }


    /**
     * Gets url
     * @return string
     */
    public function getUrl()
    {
        return $this->offsetGet('url');
    }

    /**
     * Checks url
     * @return boolean
     */
    public function hasUrl()
    {
        return $this->offsetExists('url');
    }

    /**
     * Sets url
     * @param string $url TOTP key url string that can be used to configure a key
     * @return $this
     */
    public function setUrl($url)
    {
        $this->offsetSet('url', $url);

        return $this;
    }

    /**
     * Unset url
     */
    public function unsetUrl() {
        $this->offsetUnset('url');
    }

    /**
     * Valid url
     * @return array|boolean
     */
    public function validateUrl()
    {
        if (!$this->offsetExists('url')) {
            return "Property 'url' was not initialized.";
        }
        return false;
    }

}


